// Programmierung Paralleler Prozesse, Wahlaufgabe 2.1
// Paralleles Mergesort
// master3.c -- Parent-Programm
// Matthias Jauernig, Michael Lahl, 2005

#include <stdio.h>
#include <stdlib.h>
#include </usr/local/pvm3/include/pvm3.h>

void quicksort(int a[], int l, int r);
void merge(int *A, int r);
void parMergesort(int *A, int m, int n);
void ausgabe(int *A, int s, int sortiert);

int main(void) {
  int *A;
  int i, wahl, n, m;
  FILE *datei;
  char dateiname[256];
  
  printf(	"Option waehlen:\n"
    		"---------------\n\n");
  printf("(1) Daten per Zufallsgenerator erzeugen\n");
  printf("(2) Daten eingeben\n");
  printf("(3) Daten von Datei einlesen\n");
  printf("(4) Zufaellige Daten in Datei speichern\n");
  printf("> ");
  scanf("%i", &wahl);
  switch(wahl) {
    case 1: // Daten per Zufall erzeugen
      printf("\n\n(1) Daten per Zufallsgenerator erzeugen\n");
      printf("--------------------------\n");
      printf("  m (Baumtiefe) eingeben:  ");
      scanf("%i", &m);
      printf("  n (kleinste Folge) eingeben: ");
      scanf("%i", &n);
      // Speicher bereitstellen
      A = (int*)malloc(n*(1<<m) * sizeof(int));
      // Matrix mit Zufallszahlen zwischen 0 und 100 belegen
      srand(time(0));
      for(i=0; i < n*(1<<m); i++) {
        A[i] = rand()%100;
      }
      break;
    case 2: // Daten per Hand eingeben
      printf("\n\n(2) Daten eingeben\n");
      printf("------------------\n");
      printf("  m (Baumtiefe) eingeben:  ");
      scanf("%i", &m);
      printf("  n (kleinste Folge) eingeben: ");
      scanf("%i", &n);
      printf("\n\nMatrix A eingeben:\n");
      A = (int*)malloc(n*(1<<m) * sizeof(int));

      for(i=0; i < n*(1<<m); i++) {
        printf("A[%d] = ", i);
        scanf("%d", &A[i]);
      }
      break;
    case 3: // Daten aus Datei einlesen
      printf("\n\n(3) Daten von Datei einlesen\n");
      printf("--------------------------\n");
      printf("\n  Dateiname eingeben: ");
      fflush(stdin);
      fgets(dateiname, sizeof(dateiname), stdin);
      dateiname[strlen(dateiname)-1] = '\0';
      datei = fopen(dateiname, "rb");
      if(datei != NULL) {
        fread(&m, sizeof(int), 1, datei);
        fread(&n, sizeof(int), 1, datei);
        A = (int*)malloc((n*(1<<m)) * sizeof(int));
        fread(A, (n*(1<<m)) * sizeof(int), 1, datei);
	printf("\n  Daten wurden aus '%s' geladen!\n", dateiname);
        fclose(datei);
      }else{
        printf("\n  Datei konnte nicht geoeffnet werden!\n");
        return 1;
      }        
      break;
    case 4: // Zufllige Daten in Datei speichern
      printf("\n\n(4) Zufaellige Daten in Datei speichern\n");
      printf("---------------------------------------\n");
      printf("  m (Baumtiefe) eingeben:  ");
      scanf("%i", &m);
      printf("  n (kleinste Folge) eingeben: ");
      scanf("%i", &n);
      printf("\n  Dateiname eingeben: ");
      fflush(stdin);
      fgets(dateiname, sizeof(dateiname), stdin);
      dateiname[strlen(dateiname)-1] = '\0';
      datei = fopen(dateiname, "wb");
      if(datei != NULL) {
        fwrite(&m, sizeof(int), 1, datei);
        fwrite(&n, sizeof(int), 1, datei);
        // Speicher bereitstellen
        A = (int*)malloc(n*(1<<m) * sizeof(int));
        // Matrix mit Zufallszahlen zwischen 0 und 100 belegen
        srand(time(0));
        for(i=0; i < n*(1<<m); i++) {
          A[i] = rand()%100;
        }
	ausgabe(A, n*(1<<m), 0);
        fwrite(A, (n*(1<<m)) * sizeof(int), 1, datei);
	printf("\n  Daten wurden in '%s' gespeichert!\n", dateiname);
        fclose(datei);
      }else{
        printf("\n  Datei konnte nicht geoeffnet werden!\n");
        return 1;
      }
      return 0;
      break;
    default: // ungltige Option
      printf("Ungueltige Option, breche ab...\n");
      return 1;
      break;
  }
  
  ausgabe(A, n*(1<<m), 0);
  parMergesort(A, m, n);
  ausgabe(A, n*(1<<m), 1);
  printf("\n\n");
  free(A);
  return 0;
}

void quicksort(int a[], int l, int r){		//a=Array, l=linker Rand, r=rechter Rand
    if(r>l){					//solange mehr als 1 Folgenelement existiert
        int i=l-1, j=r, tmp;			//Variableninitialisierung mit Folgenrndern
        for(;;){				//Endlosschleife; bricht ab, wenn i>=j
            while(a[++i]<a[r]);			//inkrem., bis greres  Element gefunden wird
            while(a[--j]>a[r] && j>i);		//dekrem., bis kleineres Element gefunden wird
            if(i>=j) break;			//brich ab, wenn sich die Folgenzeiger treffen
            tmp=a[i]; a[i]=a[j]; a[j]=tmp;	//tausche kleineres mit grerem Element
        }
        tmp=a[i]; a[i]=a[r]; a[r]=tmp;		//tausche Trennelement

        quicksort(a, l, i-1);			//rekursiver Aufruf fr linke Teilfolge
        quicksort(a, i+1, r);			//rekursiver Aufruf fr rechte Teilfolge
    }
}

// Mergen der beiden in A enthaltenen Teilfolgen
// r gibt dabei die Lnge einer Teilfolge an
void merging(int *A, int r){
  int i=0, j=0, k=0;
  //Hilfarray fuer resultierende Folge
  int *B = (int*)malloc(2*r * sizeof(int));
  //i = Zhler fr Folgenelemente in B
  //j = Laenge erste Folge; k = Laenge zweite Folge
  //beide Folgen innerhalb von A[]
  while(j<r || k<r){
    //(wenn Elem 2. Teilfolge grer Elem 1. Teilfolge
    //oder 2. Teilfolge leer) und 1. Teilfolge nicht leer
    // => speichere 1. Teilfolgenelement in B
    if((k>=r || A[j]<A[r+k]) && j<r){
      B[i++] = A[j++];
    }
    // => speichere 2. Teilfolgenelement in B sonst
    else{
      B[i++] = A[r+k++];
    }
  }
  //kopieren der gemergeten Folge aus B[] nach A[]
  memcpy(A, B, 2*r * sizeof(int));
  free(B);
}

void parMergesort(int *A, int m, int n) {
  int i, r, numt, *tids;

  //m Slaves starten
  tids = (int*)malloc(m * sizeof(int));
  numt = pvm_spawn( "slave3", (char**)0, 0, "", m, tids);
  if(numt != m){
    printf("Warnung: Es konnte nicht die gewuenschte Slave-Anzahl gestartet werden!");
  }
  if(numt < 0) {
    printf("\nFehler in pvm_spawn (numt): %d", numt);
    exit(1);
  }    
  for(i=0; i<numt; i++){
    if(tids[i]<0){
      printf("\nFehler in pvm_spawn (tid(%d)): %x", i, tids[i]);
    }    
  }

  //Laenge der Gesamt-Folge berechnen
  r = n*(1<<m);
  
  printf("\n");
  // verteile Teilfolgen an Slaves
  for(i=numt-1; i>=0; i--){
    pvm_initsend( PvmDataRaw );
    //Anzahl Slaves die noch vom empfangenen Slave geoeffnet werden muessen 
    pvm_pkint(&i, 1, 1);
    //Laenge der zu uebertragenden Teilfolge berechnen und verpacken
    r/=2;
    pvm_pkint(&r, 1, 1);
    //Folge einpacken
    pvm_pkint(&A[r], r, 1);
    //Paket senden
    printf("> Sende Daten an Slave [%d]\n", i);
    pvm_send(tids[i], 3);
  }

  // eigene Teilfolge sortieren
  printf("\nSortiere eigene Teilfolge...\n\n");
  quicksort(A, 0, r-1);
  
  //sortierte Teilfolgen von Slaves empfangen
  for(i=0; i<numt; i++) {
    printf("< Empfange Daten von Slave [%d]\n", i);
    //vom Slave i empfangen
    pvm_recv(tids[i], 2);
    //Teilfolge auspacken
    pvm_upkint(&A[r], r, 1);
    //Folge mergen
    merging(A, r);
    //Laenge fuer naechste zu empfangende Folge berechnen
    r *= 2;
  }
  
  //Prozess beim PVMD abmelden
  pvm_exit();
}

void ausgabe(int *A, int laenge, int sortiert){
    // Zahlenfolge ausgeben
    int i;
    printf("\n%ssortierte Zahlenfolge:"
           "\n----------------------%s\n",
	   sortiert?"":"un", sortiert?"":"--");
    printf("[ ");
    for(i=0; i<laenge; i++){
        printf("%d",A[i]);
	if(i<laenge-1){
            printf(", ");
        }
    }
    printf(" ]\n");
}
